%define with_cactus 0
%define with_tests 0
%global namedreltag -beta2
%global namedversion %{version}%{?namedreltag}
Name:          mockejb
Version:       0.6
Release:       %mkrel 0.b2.2
Summary:       Framework for running EJBs
Group:         Development/Java
License:       ASL
Url:           http://mockejb.sourceforge.net/
Source0:       http://sourceforge.net/projects/mockejb/files/mockejb/0.6-beta2/mockejb-0.6-beta2.zip
Source1:       mockejb-0.6-beta2-mod.pom
Patch0:        mockejb-0.6-nojava2html.patch
Patch1:        mockejb-0.6-build_properties.patch
Patch2:        mockejb-0.6-MockEjbContext.patch
Patch3:        mockejb-0.6-AllTests.patch

BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: apache-commons-logging
BuildRequires: cglib
BuildRequires: easymock
BuildRequires: geronimo-j2ee-1.4-api
%if %with_cactus
BuildRequires: asm
BuildRequires: aspectj 
BuildRequires: jakarta-cactus
%if %with_tests
BuildRequires: mockrunner
%endif
%endif
BuildRequires: jakarta-oro
BuildRequires: jpackage-utils
BuildRequires: junit
BuildRequires: mysql-connector-java
BuildRequires: xdoclet
BuildRequires: xml-commons-apis
Requires:      apache-commons-logging
Requires:      jpackage-utils
BuildArch:     noarch

%description
MockEJB is a lightweight framework for running EJBs. MockEJB
implements javax.ejb APIs and creates Home and EJBObject
implementation classes for your EJBs. Internally, MockEJB relies
on dynamic proxies and interceptors. MockEJB has two primary usages:
* It allows for running EJBs outside of the container for unit
 testing.You can run EJBs directly from your favorite IDE with
 the minimal setup effort.
* It allows for deploying mock EJBs (i.e., mock EJB implementation
 classes) into the container. Mock EJBs provide very effective way
 of isolating EJBs under test from the rest of the application.
 Mock EJBs return predefined test data and can override the actual
 "non-mock" deployed EJBs. Once again, the purpose of MockEJB is
 twofold and it works inside and outside of the container. So you
 can benefit from it even if you continue running all your test
 classes inside the container using Cactus.
Additionally, MockEJB comes with the "mock" implementation of non-EJB
APIs. Currently it provides in-memory JNDI and JMS implementations
which can be used independently from MockEJB's EJB support.
MockEJB is not a full-blown EJB container. It does not fully implement
J2EE/EJB specs, however it supports all vital APIs. 

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
MockEJB - Framework for running EJBs.

This package contains javadoc for %{name}.

%package manual
Group:         Development/Java
Summary:       Manual for %{name}

%description manual
MockEJB - Framework for running EJBs.

This package contains documentation for %{name}.

%prep
%setup -q -n mockejb-%{version}-beta2

for j in $(find . -name "*.jar"); do
   mv $j $j.no
done
for c in $(find . -name "*.class"); do
   rm -f $c
done
cp build.properties.sample build.properties
%patch0 -p0
%patch1 -p0
%patch2 -p0

%if %with_cactus
mkdir cactus-lib
pushd cactus-lib
  ln -sf $(build-classpath aspectjrt) .
  ln -sf $(build-classpath cactus-14/cactus) .
  ln -sf $(build-classpath asm/asm) .
popd
%if %with_tests
%patch3 -p0
    ln -sf $(build-classpath mockrunner/mockrunner) cactus-lib/
    ln -sf $(build-classpath mockrunner/mockrunner-ejb) cactus-lib/
%endif
%else
#  remove jakarta-cactus support
  rm src/org/mockejb/OptionalCactusTestCase.java
%endif

cp build.properties build_test.properties

sed -i 's,<copy file="${commons-logging.jar.path}" todir="${build.release.dir}/lib" />,<!--copy file="${commons-logging.jar.path}" todir="${build.release.dir}/lib" />,'    build_mockejb.xml
sed -i 's,<copy file="${oro.jar.path}" todir="${build.release.dir}/lib" />,<copy file="${oro.jar.path}" todir="${build.release.dir}/lib" /-->,'    build_mockejb.xml

%build
#export JAVA_HOME=/usr/lib/jvm/java-1.5.0
export CLASSPATH=""
%if %with_tests
export CLASSPATH=$(build-classpath mockrunner)
ant build test
%else
#CLASSPATH=$CLASSPATH:$(build-classpath geronimo-j2ee-1.4-api)
ant -f build_mockejb.xml  build
%endif

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
install -pm 644 build/mockejb/mockejb-%{version}-beta2/lib/mockejb.jar \
  %{buildroot}%{_javadir}/mockejb-%{version}.jar

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do 
    ln -s  ${jar} ${jar/-%{version}/};
  done
)


mkdir -p %{buildroot}%{_mavenpomdir}
%add_to_maven_depmap org.mockejb mockejb %{namedversion} JPP mockejb
install -m 644 %{SOURCE1} %{buildroot}%{_mavenpomdir}/JPP-mockejb.pom

mkdir -p %{buildroot}%{_javadocdir}/mockejb-%{version}
cp -pr build/mockejb/mockejb-%{version}-beta2/doc/javadoc/* %{buildroot}%{_javadocdir}/mockejb-%{version}
ln -s mockejb-%{version} %{buildroot}%{_javadocdir}/mockejb
rm -rf build/mockejb/mockejb-%{version}-beta2/doc/{javadoc,java2html}

mkdir -p %{buildroot}%{_docdir}/mockejb
cp -pr build/mockejb/mockejb-%{version}-beta2/doc/* %{buildroot}%{_docdir}/mockejb

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/mockejb-%{version}.jar
%{_javadir}/mockejb.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc %{_docdir}/mockejb/ReleaseNotes.html

%files javadoc
%{_javadocdir}/mockejb-%{version}
%{_javadocdir}/mockejb

%files manual
%doc %{_docdir}/mockejb
%exclude %{_docdir}/mockejb/ReleaseNotes.html



%changelog

* Mon Nov 28 2011 gil <gil> 0.6-0.b2.2.mga2
+ Revision: 173800
- added maven support

* Tue Sep 06 2011 dmorgan <dmorgan> 0.6-0.b2.1.mga2
+ Revision: 139001
- Adapt to mageia guidelines

  + gil <gil>
    - imported package mockejb


* Sat Jul 02 2011 gil <gil> 0.6-0.%%mkrel
- initial rpm
